P586
%NOINCL
INCLUDE \TASM\INCLUDE\WIN32.INC
IDEAL
MODEL NT Flat,StdCall

INCLUDELIB  "\TASM\LIB\IMPORT32"

EXTRN   GetStdHandle: PROC
EXTRN   CloseHandle: PROC
EXTRN   CreateFileA: PROC
EXTRN   ReadFile: PROC
EXTRN   WriteFile: PROC
EXTRN   GetCommandLineA: PROC
EXTRN   FindFirstFileA: PROC
EXTRN   FindNextFileA: PROC
EXTRN   FindClose: PROC
EXTRN   SetFilePointer: PROC
EXTRN   lstrcatA: PROC
EXTRN   lstrcpyA: PROC

DATASEG
AppTitle        db 'MP3 Split v1.0 - (c) Copyright 2000,2001 bl!tz/AmoK',13,10
                db 'For latest cracks and tools visit www.amok.am!',13,10,13,10,0

Splitname       db 'output',0
SplitExt        db '.mp3',0


V1L3    dw 0,32,40,48,56,64,80,96,112,128,160,192,224,256,320,0
V2L3    dw 0,8,16,24,32,64,80,56,64,128,160,192,224,256,320,0
Sample  dw 44100,22050,11025
        dw 48000,24000,12000
        dw 32000,16000,8000
        dw 0,0,0

ENoCommand      db 'No command specified. Please type "mp3split h" to get '
                db 'help.',13,10,0
EWrongCommand   db 'Command not recognized. Please type "mp3split h" to get '
                db 'help',13,10,0
ENotEnoughCom   db 'Too few or too many arguments specified.'
NextLine        db 13,10,0
EIO             db 'I/O Error.',13,10,0

LABEL   EHelp BYTE
db  'Usage: h',13,10
db  '               Displays help.',13,10,13,10
db  '       s File BlockSize',13,10
db  '               Splits "File" into blocks with a size of BlockSize KBs named'
db 13,10
db  '               "output?.mp3".'
db 13,10,13,10
db  '       c NewFile FileOrMask [FileOrMask ...]',13,10
db  '               Combines all files.',13,10,13,10,0

UDATASEG
hConOut dd ?
hIn     dd ?
hout    dd ?

LABEL   Buf    BYTE
Scratch1        dd ?
Scratch2        dd ?

        db 256-8 dup(?)

CLineParts      dd 16 dup(?)
NumClineParts   dd ?

MP3Frame        db 8000h dup(?)

CODESEG
Start:  call GetStdHandle ,STD_OUTPUT_HANDLE
        mov [hConOut],eax

        mov eax,offset AppTitle
        call WriteStr

        call GetCommandLineA
        mov ecx,offset CLineParts
        call ProcessCommandLine
        mov [NumClineParts],eax

        cmp eax,2
        jb DispNoCommand

        mov edi,eax

        push offset Done
        mov ecx,[CLineParts+4]
        mov cl,[ecx]

        cmp cl,'s'
        je SplitProc
        cmp cl,'c'
        je CombineProc
        cmp cl,'h'
        je HelpProc

        mov eax,offset EWrongCommand
        jmp DispError

Done:
        EXITCODE
DispIO:
        mov eax,offset EIO
        jmp short DispError
DispNotEnough:
        mov eax,offset ENotEnoughCom
        jmp short DispError
DispNoCommand:
        mov eax,offset ENoCommand
DispError:
        call WriteStr
        EXITCODE

PROC    HelpProc
        mov eax,offset EHelp
        jmp WriteStr
ENDP

PROC    Num2Str                         ;eax = Num
USES    ESI,EBX                         ;ecx = Offs

        mov esi,ecx
        xor edx,edx
        mov ebx,10
        xor ecx,ecx
@@Lp:
        div ebx
        or dl,30h
        push edx
        xor edx,edx
        inc ecx
        cmp eax,0
        jne @@Lp

;        mov esi,[@@Offs]
@@Lp2:  pop eax
        mov [byte ptr esi],al
        inc esi
        loop @@Lp2
        mov [byte ptr esi],0
@@Complete:
        ret
ENDP

PROC    Str2Num                 ;eax = offset string
USES    ESI,EBX
        mov esi,eax
        xor eax,eax
        mov ebx,10
        xor edx,edx
@@Loop: cmp [byte esi],0
        je @@Complete
        cmp [byte esi],30h
        jb @@complete
        cmp [byte esi],39h
        ja @@complete
        mul ebx
        mov dl,[byte ptr esi]
        and dl,0fh
        add eax,edx
        inc esi

        jmp @@Loop
@@Complete:
        ret                             ;Zahl in EAX
ENDP


PROC    SplitProc               ;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
LOCAL   @@MaxSize: DWORD
        cmp [NumCLineParts],4
        jne DispNotEnough

        mov eax,[ClineParts+4*3]
        call Str2Num
        shl eax,10
        mov [@@MaxSize],eax

        mov eax,[ClineParts+4*2]
        call CreateFileA ,eax,GENERIC_READ,0,0,OPEN_EXISTING,0,0
        cmp eax,-1
        je DispIO
        mov [hIn],eax

        xor edi,edi             ;CurPart

        jmp @@IntoLoop
@@Loop:
        call CloseHandle ,[hOut]
        inc edi
@@IntoLoop:
        xor esi,esi             ;CurSize
        mov eax,edi
        mov ecx,offset Buf
        call Num2Str

        call lstrcpyA ,offset MP3Frame,offset SplitName
        call lstrcatA ,offset MP3Frame,offset Buf
        call lstrcatA ,offset MP3Frame,offset SplitExt

        mov eax,offset MP3Frame
        call WriteStr
        mov eax,offset NextLine
        call WriteStr

        call CreateFileA ,offset MP3Frame,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
        cmp eax,-1
        je DispIO
        mov [hOut],eax

@@FindFrame:
        call GetMP3FrameLength ,[hIn]
        test eax,eax
        jnz @@FoundOne

        call ReadFile ,[hIn],offset Scratch1,1,offset Scratch2,0
        cmp [Scratch2],0
        je @@FileDone                   ;EOF?
        jmp @@FindFrame
@@FoundOne:

        lea ecx,[esi+eax]
        cmp [@@MaxSize],ecx
        jbe @@Loop
        add esi,eax
        
        mov ebx,eax
        call ReadFile ,[hIn],offset MP3Frame,eax,offset Scratch1,0
        cmp [Scratch1],ebx
        jne @@FindFrame

        call WriteFile ,[hOut],offset MP3Frame,ebx,offset Scratch1,0
        test eax,eax
        jz DispIO

        jmp @@FindFrame

@@FileDone:
        call CloseHandle ,[hIn]
        call CloseHandle ,[hOut]
        ret
ENDP

PROC    ProcSingle              ;EDX = Filename
        pushad
        mov esi,edx
        mov eax,edx
        call WriteStr
        mov eax,offset NextLine
        call WriteStr

        call CreateFileA ,esi,GENERIC_READ,0,0,OPEN_EXISTING,0,0
        cmp eax,-1
        je DispIO
        mov [hIn],eax

@@FindFrame:
        call GetMP3FrameLength ,[hIn]
        test eax,eax
        jnz @@FoundOne


        call ReadFile ,[hIn],offset Scratch1,1,offset Scratch2,0
        cmp [Scratch2],0
        je @@FileDone                   ;EOF?
        jmp @@FindFrame
@@FoundOne:

        mov ebx,eax
        call ReadFile ,[hIn],offset MP3Frame,eax,offset Scratch1,0
        cmp [Scratch1],ebx
        jne @@FindFrame
        call WriteFile ,[hOut],offset MP3Frame,ebx,offset Scratch1,0
        test eax,eax
        jz DispIO

        jmp @@FindFrame
@@FileDone:
        call CloseHandle ,[hIn]
        popad
        ret
ENDP

PROC    ProcMask                ;EDX = Filemask
        pushad
        sub esp,size WIN32_FIND_DATA+16

        call FindFirstFileA ,edx,esp
        cmp eax,-1
        je @@Done
        mov edi,eax
@@Loop:
        lea edx,[(WIN32_FIND_DATA esp).cFileName]
        call ProcSingle

        call FindNextFileA ,edi,esp
        test eax,eax
        jnz @@Loop
        call FindClose ,edi

@@Done:
        add esp,size WIN32_FIND_DATA+16
        popad
        ret
ENDP

PROC    CombineProc
        cmp [NumCLineParts],4
        jb DispNotEnough

        mov eax,[ClineParts+4*2]
        call CreateFileA ,eax,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
        cmp eax,-1
        je DispIO
        mov [hOut],eax

        mov edi,3
@@Loop:
        mov esi,[ClineParts+edi*4]
        mov edx,esi
        push offset @@DoNext
@@CheckStr:
        lodsb
        test al,al
        je ProcSingle
        cmp al,'?'
        je ProcMask
        cmp al,'*'
        je ProcMask
        jmp @@CheckStr

@@DoNext:
        inc edi
        cmp edi,[NumClineParts]
        je @@Done
        jmp @@Loop
@@Done:
        call CloseHandle ,[hout]
        ret
ENDP


PROC    WriteStr                ;EAX = offset String

        push esi
        push ebp
        push eax
 
        mov ebp,esp

        mov esi,eax
        xor ecx,ecx
@@Lp:   lodsb
        test al,al
        jz @@Done
        inc ecx
        jmp @@Lp
@@Done:

        pop eax

        sub esp,4
        call WriteFile ,[hConOut],eax,ecx,ebp,0
        add esp,4

        pop ebp
        pop esi
        ret
ENDP

PROC    ProcessCommandLine              ;EAX = pCommandLine
                                        ;ECX = pPointerTab

        mov esi,eax
        xor edx,edx             ;Hochkommas?
        mov edi,ecx
        mov ecx,1               ;Anzahl der Segmente
        mov [edi],esi

@@PrLoop:
        lodsb
        cmp al,' '
        je @@Space
        cmp al,''''
        je @@Quote
        cmp al,'"'
        je @@Quote

        test al,al
        jz @@Done
        cmp al,0ah
        je @@Done
        cmp al,0dh
        je @@Done
        jmp @@PrLoop
@@Quote:
        not edx
        jmp @@PrLoop
@@Space:
        test edx,edx
        jnz @@PrLoop

        xor eax,eax

        cmp [byte esi],' '
        je @@PrLoop
        cmp [byte esi],0
        je @@PrLoop


        mov [byte esi-1],0
        mov [edi+ecx*4],esi
        inc ecx
        cmp ecx,16
        je @@Done
        jmp @@PrLoop

@@Done:
        mov [byte esi-1],0

        mov eax,ecx
        ret
ENDP

;I wrote the following part some time ago and I am too tired to rewrite it.
;So I just compiled the old PASCAL code with FreePASCAL using best
;optimization. Looks awful...
PROC    GETMP3FRAMELENGTH
		push	ebp
		mov	ebp,esp
		sub	esp,20
		push	edi
		push	esi
		push	ebx
                mov     [dword ebp-4],0

                lea     ecx,[ebp-8]
                lea     eax,[ebp-12]

                call    ReadFile ,[dword ebp+8],ecx,4,eax,0
                neg     [dword ebp-12]
                call    SetFilePointer ,[dword ebp+8],[dword ebp-12],0,FILE_CURRENT

                mov     ecx,[dword ebp-8]
		bswap	ecx
                mov     [dword ebp-8],ecx
                mov     eax,[dword ebp-8]
		shr	eax,21
		cmp	eax,2047
		jne	@@3
                mov     eax,[dword ebp-8]
		shr	eax,17
		and	eax,3
		cmp	eax,1
		jne	@@3
                mov     eax,[dword ebp-8]
		shr	eax,19
		and	eax,3
		jb	@@3
		cmp	eax,3
		ja	@@3
		jmp	[@@23+eax*4]
@@9:
                mov     [byte ebp-13],1
		jmp	@@21
@@7:
                mov     [byte ebp-13],2
		jmp	@@21
@@5:
                mov     [byte ebp-13],3
		jmp	@@21
@@22:
		jmp	@@3
@@21:
                movzx   eax,[byte ebp-13]
		cmp	eax,1
		jne	@@31
                mov     eax,[dword ebp-8]
		shr	eax,12
		and	eax,15
                mov     di,[word V1L3+eax*2]
                mov     [word ebp-16],di
		jmp	@@34
@@31:
                mov     eax,[dword ebp-8]
		shr	eax,12
		and	eax,15
                mov     di,[word V2L3+eax*2]
                mov     [word ebp-16],di
@@34:
                mov     eax,[dword ebp-8]
		shr	eax,10
		and	eax,3
		imul	eax,6
                movzx   edx,[byte ebp-13]
                mov     di,[word SAMPLE+eax+edx*2-2]
                mov     [word ebp-18],di
                mov     eax,[dword ebp-8]
		shr	eax,9
		and	eax,1
                mov     [byte ebp-19],al
                movzx   eax,[word ebp-18]
		test	eax,eax
		je	@@3
                movzx   eax,[word ebp-16]
		test	eax,eax
		je	@@3
		imul	eax,1000
		imul	eax,144
                movzx   edx,[word ebp-18]
		mov	edi,edx
		cdq
		idiv	edi
                movzx   edx,[byte ebp-19]
		add	edx,eax
                mov     [dword ebp-12],edx
                mov     edi,[dword ebp-12]
                mov     [dword ebp-4],edi
@@3:
                mov     eax,[dword ebp-4]
		pop	ebx
		pop	esi
		pop	edi
		leave
		ret	4
@@23		DD	offset @@5
		DD	offset @@22
		DD	offset @@7
		DD	offset @@9
ENDP

END Start
